#include "Settings.h"
//#include <iostream.h>

#define CONF_ADDPROP(_type, _msgt, _cast, _byref, _name, _strname, _default) \
void Settings::Set##_name(_type value)\
{\
	_conf##_name = value;\
}\
\
_type Settings::##_name()\
{\
	return _conf##_name;\
}\


#include "SettingsProps.h"
#undef CONF_ADDPROP

Settings::Settings()
{
	BPath prefPath;

#define CONF_ADDPROP(_type, _msgt, _cast, _byref, _name, _strname, _default) \
	_conf##_name = _default; \
			
#include "SettingsProps.h"
#undef CONF_ADDPROP

	find_directory(B_USER_SETTINGS_DIRECTORY, &prefPath);
	prefPath.Append(SETTINGS_FILE);
		
	_settingsFile.SetTo(prefPath.Path(), B_READ_WRITE | B_CREATE_FILE);
	
	if (_settingsMessage.Unflatten(&_settingsFile) == B_OK){
	

#define CONF_ADDPROP(_type, _msgt, _cast, _byref, _name, _strname, _default) \
		if (_settingsMessage.Find##_msgt(_strname, _cast &_conf##_name) != B_OK) \
			printf("Settings::Settings();\tFailed to load " _strname " from settings file. Using default\n"); \
			
#include "SettingsProps.h"
#undef CONF_ADDPROP

	}
	else
	{
		printf("Settings::Settings()\nUnable to open settings file (either corrupted or doesn't exist), using defaults.\n");		
	}
	
	_settingsFile.Unset();		
}

Settings::~Settings()
{
	BPath prefPath;
	find_directory(B_USER_SETTINGS_DIRECTORY, &prefPath);
	prefPath.Append(SETTINGS_FILE);
	
	//clobber existing settings and write in new ones
	_settingsFile.SetTo(prefPath.Path(), B_READ_WRITE | B_ERASE_FILE);


	//empty message and refill it with whatever has been set
	_settingsMessage.MakeEmpty();

#define CONF_ADDPROP(_type, _msgt, _cast, _byref, _name, _strname, _default) \
	_settingsMessage.Add##_msgt(_strname, _byref _conf##_name);
			
#include "SettingsProps.h"
#undef CONF_ADDPROP


	//write message to settings file
	if (_settingsMessage.Flatten(&_settingsFile) != B_OK)
		printf("Error occurred writing settings\n");

	_settingsFile.Unset();	
}

