#ifndef COMMON_H
#define COMMON_H

#include <stdio.h>

#include <AppKit.h>
#include <InterfaceKit.h>
#include <String.h>
#include <StorageKit.h>

/***************************************************
	common.h
	Constants used by app
***************************************************/

// used to check the image to use to get the resources
#define APP_NAME "DBGoogleLang"
#define APP_SIG "application/x-vnd.mmu.DBGoogleLang" 
#define SETTINGS_FILE "x-vnd.mmu.DBGoogleLang_settings"

//names of data segments in settings file
//also used in messages

#define DEFAULT_DELAY 500000LL


// messages

#define ADD_TO_TRAY 'zATT'
#define REMOVE_FROM_TRAY 'zRFT'

#define OPEN_SETTINGS 'zOPS'

#define MSG_START_SEARCH 'ggSS'
#define MSG_SET_BROWSER 'ggSB'
#define GG_BROWSER "gg:browser"
#define MSG_SET_LANGUAGE 'ggSL'
#define GG_LANGUAGE "gg:language"
#define MSG_TOOGLE_AUTOCLOSE 'ggTA'

#define MSG_UPDATE 'ggUP'

#define USE_DEFAULT_BROWSER 0
#define USE_NET_POSITIVE 1
#define USE_OPERA 2
#define USE_MOZILLA 3
#define USE_FIREBIRD 4

#define USE_DEFAULT_LANGUAGE 0
#define USE_LANG_DE 1
#define USE_LANG_FR 2
#define USE_LANG_IT 3
#define USE_LANG_SE 4
#define USE_LANG_EN 5
#define USE_LANG_PT 6
#define USE_LANG_SP 7
#define USE_LANG_RU 8
#define USE_LANG_NL 9

#endif
